; define LEVEL_1_6, LEVEL_2, LEVEL_3_5 or LEVEL_4

	include	misc/deliplayer.i
	include	exec/libraries.i
	include	lvo/exec_lib.i
	include	hardware/custom.i
	include	hardware/dmabits.i

_custom=$dff000

	SECTION player,code
	PLAYERHEADER tags
	dc.b	"$VER: "
	IFD	LEVEL_1_6
	dc.b	"CUST.Agony_level_1_&_6"
	ENDC
	IFD	LEVEL_2
	dc.b	"CUST.Agony_level_2"
	ENDC
	IFD	LEVEL_3_5
	dc.b	"CUST.Agony_level_3_&_5"
	ENDC
	IFD	LEVEL_4
	dc.b	"CUST.Agony_level_4"
	ENDC

	dc.b	" (04.04.2001)",10
	dc.b	"from Art & Magic DeliPlayer by MORB/CdBS Software",0
	even

tags	dc.l	DTP_CustomPlayer,1
	dc.l	DTP_InitPlayer,initply
	dc.l	DTP_EndPlayer,endply
	dc.l	DTP_InitSound,mt_init
	dc.l	DTP_Interrupt,mt_int
	dc.l	DTP_EndSound,mt_end
	dc.l	DTP_Volume,setvol
	dc.l	DTP_Balance,setvol
	dc.l	DTP_Flags,PLYF_SONGEND
	dc.l	TAG_DONE

delibase
	dc.l	0

initply	move.l	a5,delibase
	move.l	dtg_AudioAlloc(a5),a0
	jsr	(a0)
	tst.l	d0
	bne.s	.fail

	lea	MUSDATA,a0
	move.l	a0,d1
	move.w	($E2,a0),d2
	add.w	#$E2,d2
	lea	(a0,d2.w),a1
	move.w	($15E,a0),d2
	add.w	#$155,d2
	sub.l	(a0,d2.w),d1
	ext.l	d2
	add.l	d2,d1
	add.l	#9,d1
	add.l	a0,d2
	sub.l	a1,d2
	sub.l	#$28,d2
	lsr.l	#2,d2
	moveq	#4,d3
1$	add.l	d1,(a1)
	addq.l	#8,a1
	dbra	d3,1$
2$	add.l	d1,(a1)+
	dbra	d2,2$

	; patch the code to set the volume correctly
	move.w	#$4EB9,MUSDATA+$17C
	move.l	#.volume_patch,MUSDATA+$17E

	; patch the code to detect songend (two versions)
	cmpi.l	#$1020408,MUSDATA+$20E
	beq.b	3$
	move.w	#$4EB9,MUSDATA+$420
	move.l	#.songend_patch,MUSDATA+$422
	bra.b	4$
3$	move.w	#$4EB9,MUSDATA+$424
	move.l	#.songend_patch,MUSDATA+$426
4$
	; flush the caches
	move.l	4.w,a6
	cmp.w	#36,LIB_VERSION(a6)
	bcs.s	5$
	jsr	_LVOCacheClearU(a6)
5$
	; call the module init routine
	jsr	MUSDATA	
	moveq	#0,d0
.fail	rts

.volume_patch
	movem.l	d1/a0,-(sp)
	lsr.w	#6,d0			; d0 = volume
	move.w	a4,d1			; d1 = $00dff0x0 [x=0-3]
	lsr.w	#4,d1			;    = $00df0f0x
	ext.w	d1			;    = $00df000x (=$000x.w = channel.w)
	lea	volumes(pc),a0
	move.b	(a0,d1.w),d1		; get volume level for this channel
	mulu.w	d1,d0
	lsr.w	#6,d0
	move.w	d0,$A8(a4)		; set volume in $dff0a8, b8, c8, d8
	movem.l	(sp)+,d1/a0
	rts

.songend_patch
	move.l	a0,-(sp)
	move.l	delibase(pc),a0
	move.l	dtg_SongEnd(a0),a0	; call songend notification routine
	jsr	(a0)
	movea.l	(sp)+,a0
	move.b	(a1),d0			; repeat code we overwrote with patch
	move.w	($16,a0),d1
	rts

endply	move.l	dtg_AudioFree(a5),a0
	jmp	(a0)

mt_init	move.l	a5,-(sp)
	moveq	#1,d6
	moveq	#1,d7
	jsr	MUSDATA+$A2		; init channel 1
	moveq	#2,d6
	moveq	#2,d7
	jsr	MUSDATA+$A2		; init channel 2
	moveq	#3,d6
	moveq	#3,d7
	jsr	MUSDATA+$A2		; init channel 3
	movea.l	(sp)+,a5
	rts

mt_int	movem.l	d2-d7/a2-a6,-(sp)
	jsr	MUSDATA+$84		; call the main playing interrupt
	movem.l	(sp)+,d2-d7/a2-a6
	rts

mt_end	move.w	#$000f,$dff096		; turn off all audio
	rts

setvol	lea	volumes(pc),a0
	move.w	dtg_SndVol(a5),d0
	move.w	dtg_SndRBal(a5),d1
	mulu.w	d0,d1
	lsr.w	#6,d1
	move.b	d1,1(a0)		; chan 1 master vol = (rbal*vol)/64
	move.b	d1,2(a0)		; chan 2 master vol = (rbal*vol)/64
	mulu.w	dtg_SndLBal(a5),d0
	lsr.w	#6,d0
	;move.b	d0,0(a0)		; chan 0 master vol = (lbal*vol)/64
	move.b	d0,3(a0)		; chan 3 master vol = (lbal*vol)/64
	rts

volumes	dc.b	0,0,0,0

	section	music,data,chip
MUSDATA
	IFD	LEVEL_1_6
	incbin	"AAM.level_1_&_6"
	ENDC
	IFD	LEVEL_2
	incbin	"AAM.level_2"
	ENDC
	IFD	LEVEL_3_5
	incbin	"AAM.level_3_&_5"
	ENDC
	IFD	LEVEL_4
	incbin	"AAM.level_4"
	ENDC
